/*******************************************************************
**** GLYN GmbH Am Wrtzgarten8 D-65510 Idstein/Ts. Germany *********
********************************************************************
****	Author	: P. Drwald									****
****	Version	: 1.0											****
****	Changes	: 28.07.2004									****
****	MCU		: MB90543										****
****	file	: Main.c										****
********************************************************************
****	Description : 											****
****	Applikationsbeispiel MMC								****
****	Dateien:  	MMC.c	- Routinen zum Ansprechen der MMC	****
****						  ber die SIO-Schnittstelle		****
****				uart.c	- serielle Schnittstelle (Terminal)	****
****				utils.c	- Hilfsprogramme(z.B.Suchfunktionen)****
*******************************************************************/

#include "mb90540.h"

#define LED PDR2_P21


extern unsigned long int seek(unsigned long int);
extern unsigned long int seek_pat(void);  
extern unsigned long Get_long(void);
extern unsigned char write_block(unsigned long int,char);



void menue (void);

//unsigned long DelayCount; 
unsigned char PortCount,found_pat;
unsigned char card1_status,card2_status;
unsigned long int length_file,start_adr;
unsigned char data[512];
char input[64];
extern unsigned long int memcap[2];

void main(void)
{
 unsigned long int adr,block;
 unsigned int x,offset;
 unsigned char len,byte;
 
 found_pat=0;
 
 Init_SIO();
 InitIrqLevels();
 __set_il(7);                /* allow all levels */
    __EI();                     /* globaly enable interrupts */
    

  DDR2 = 0x1B; /* set parallel port direction register*/
   
  
    
  PDR2= 0xFF; 
  
  InitUart();

	
  
  card1_status=Init_MMC(0);
  card2_status=0;
  
  menue();
    
      
 
  adr=0; 
   
  while(1) 
  { 
  
  
  
    switch(Getch())
    {
     case '1' : card1_status=Init_MMC(0);
  				card2_status=0;
  				if (card1_status==1) 
                {
                   Send_CSD(0);
				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
  				   Puts("Karte 1: ");
  				   Print_memcap(memcap[0]);
  				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
  				}
				if (card2_status==1) 
                {
				   Send_CSD(1);
				   Puts("Karte 2: ");
  				   Print_memcap(memcap[1]);
				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
				}

				Getch();
				menue();

    			break;
	 case '2' : if (card1_status==1) 
                {
                   LED = 0;
                   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
  				   Puts("Karte 1: ");
                   Send_CID(0);
                   Send_CSD(0);
                   hex_csd_cid();
				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
  				   LED=1;
  				}
				if (card2_status==1) 
                {
				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
  				   Puts("Karte 2: ");
                   Send_CID(1);
                   Send_CSD(1);
                   hex_csd_cid();
				   Putch (10); /* Linefeed*/
  				   Putch (13); /* CR */
				}

				Getch();
				menue();

    			break;
    			
 	 case '3' :	Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  				Puts("Adresse Karte 1: ");
  				set_blocklen(512,0);
  				block=Get_long()/0x200;
  				do
  				{
  				 LED = 0;
  				 hexdump(block*0x200);		/* nur blockweise */
  				 LED = 1;
  				 block++;
				}while (Getch()=='n');
				 menue();

    			break;
     case '4' : Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  			    Puts("Suchstring: ");
  			    len=Gets();
  			    adr=seek_pat();
  			    block=adr/0x200;
  			    if(USR0_RDRF == 0)hexdump(block*0x200);
  			    Getch();
				menue();

    			break;
    			
     case '5' : Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  			    Puts("Adresse: ");
  			    adr=Get_long();
  			    block=adr/0x200;
  				offset=adr-(block*0x200);
  				read_single_block(block*0x200,0);
  			    Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  			    Puts("Byte: ");
  			    data[offset]=Get_byte();
  			    
  			    write_block(block*0x200,0);
  			    hexdump(block*0x200);
  			    Getch();
				menue();

    			break;
     case '6' : Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  				
  			    Puts("Kopieren: ");
  			    Putch (10); /* Linefeed*/
  				Putch (13); /* CR */

  			    
  			    if ((memcap[1]>=memcap[0])&memcap[0]>0)
  			    {
  			        set_blocklen(512,0);
  			      	set_blocklen(512,1);
   			        for(block=0;((block*0x200)<memcap[0])&(USR0_RDRF == 0);block++)
  			      {
  			        read_single_block(block*0x200,0);
  			        write_block(block*0x200,1);
			        Print_Long_Integer(block); 
  				    Putch (13); /* CR */
  				  } 
  			    }
  			    else Puts(" Kartengre falsch!");
  			    if(USR0_RDRF == 1) 
  			    {
  			     Puts(" Abbruch: ");
  			     Print_Long_Integer(block+0x200);
  			     Getch(); 
  			    }
  			    

				menue();

    			break;

     case '7' : Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  				if (found_pat==0) 
  				{
  				  Puts("Suche Startkennung... ");
  				  Putch (10); /* Linefeed*/
  				  Putch (13); /* CR */
  				  adr=seek(0);
  				  if(adr!=0) found_pat=1;
  				  block=adr/0x200;
  				  offset=adr-(block*0x200);
  				} 
  				if (found_pat==1)
  				{ 
  				  read_single_block(block*0x200,0);
  			      Puts("Schreibstring: ");
  			      len=Gets();
  			      for(x=0;x<len;x++) data[offset+x]=input[x];
			 	  set_blocklen(512,0);
  			      write_block(block*0x200,0);
  			      hexdump(block*0x200);

  			     }
  			     else
  			     {
  			      Putch (10); /* Linefeed*/
  				  Putch (13); /* CR */
                  Puts("Keine Startkennung gefunden ");
                 } 

				Getch();
				menue();

    			break; 
     case '8' : Putch (10); /* Linefeed*/
  				Putch (13); /* CR */
  			    Puts("Fllbyte: ");
  			    byte=Get_byte();
  			    for(x=0;x<512;x++)data[x]=byte;
  			    for(block=0;((block*0x200)<memcap[0])&(USR0_RDRF == 0);block++)write_block(block*0x200,0);
  			    if(USR0_RDRF == 1) Puts(" Abbruch: ");
  			    Print_Long_Integer(block*0x200); 
  			    Getch();
  			    menue();

    			break;
    			

    
    }
    /*if (card1_status==1) 
    {
    
      Send_CID(0);
      Send_CSD(0);
      hex_csd_cid();

      hexdump(Get_long());
      //start_adr=seek(0);
      DelayCount=0;
//      }
            
    }


    if (card2_status==1)
    {
     //Send_CID(1);
     Send_CSD(1);
    }*/ 

    while(0);
    
 
 
   }
}

void menue (void)	/* schreibt ein Men */
{
 /* char c; */
 int i;
	Putch(10);
	Putch(13);
	Putch(13);
	Puts("Menue:");
	Putch(10);
	Putch(13);
 for (i=0; i<40; i++)
  {
	Putch ('*');			/* send it out */
  }
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  1 - Karte einfgen                  *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  2 - CID/CSD anzeigen                *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  3 - Hexdump (n -> weiter)           *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  4 - Suche String                    *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  5 - Daten ndern                    *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  6 - Copy Slot 1 nach 2              *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts ("*  7 - Demoprogamm: schreibe in Datei  *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
   Puts ("*  8 - Low Level Formatierung         *");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */


  for (i=0; i<40; i++)
  {
	Putch ('*');			/* send it out */
  }
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
}

