/*******************************************************************
**** GLYN GmbH Am Wrtzgarten8 D-65510 Idstein/Ts. Germany *********
********************************************************************
****	Author	: P. Drwald									****
****	Version	: 1.0											****
****	Changes	: 23.09.2002									****
****	MCU		: MB90543										****
****	file	: utils.c										****
********************************************************************
****	Description : 											****
****	Applikationsbeispiel MMC								****
****	utils.c	- Hilfsprogramme(z.B.Suchfunktionen)			****
*******************************************************************/

#include "mb90540.h"


unsigned long int seek(unsigned long int); 

void hex_csd_cid(void);
void hexdump(long int);
unsigned long int seek_pat(void); 

extern unsigned long int memcap[2];
extern unsigned char data[512];
extern unsigned long int length_file;
extern unsigned char CID[16],CSD[16];
extern char input[32];


void hex_csd_cid(void)			/* print CID and CSD */
{
  unsigned char x,y;
  
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts("CID:");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  for(x=0;x<16;x++)
  {
    Print_Byte(CID[x]);
    if(x<15) Putch('-');
  }
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Puts("CSD:");
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  for(x=0;x<16;x++)
  {
    Print_Byte(CSD[x]);
    if(x<15) Putch('-');
  }
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
}    


void hexdump(long int start)
{
 unsigned char x,y;
 unsigned int tescht;
 char a;
  Putch (10); /* Linefeed*/
 Putch (13); /* CR */
 tescht=read_single_block(start,0)&0xFF00;
 if(tescht)
  {
   if(tescht==0xFF00)Puts("Kartenlesefehler1");
   if(tescht==0xFE00)Puts("Kartenlesefehler2");

   return;
  } 
 for (y=0;y<32;y++)
 {
  Putch (10); /* Linefeed*/
  Putch (13); /* CR */
  Print_Long_Integer(start+(y*16)); 
  Putch(':');
  for(x=0;x<16;x++)
  {
    Print_Byte(data[(y*16)+x]);
    if(x<15) Putch('-');
  }
  Putch(32);
  for(x=0;x<16;x++)
  {
   a=data[(y*16)+x];
    if(a>31 & a<127) Putch(a);
    else Putch('.');
  }

 }
 Putch (10); /* Linefeed*/
 Putch (13); /* CR */
}      

unsigned long int seek(unsigned long int start)         /* sucht nach Pattern in Datei */
{
 unsigned long int adr,pot;
 unsigned char y,end,da,b,found;
 unsigned int xoff,j,offset;
 unsigned int sa_rate;
 unsigned char pattern[]="STARTKENNUNG:";

 adr=start;
 offset=0;
 found =0;
 while ((adr<memcap[0])&(found==0)&(USR0_RDRF == 0))
 {
  if( read_single_block(adr,0)&0xFF00)
  {
   //print ("Kartenlesefehler");
   return;
  }
  y=0;
  xoff=0;
  end=0;
  while (end!=1)
  {
    da=data[xoff];
    if (da==pattern[y])
    {
     y++;
     if (pattern[y]==0)
     {
      found=1;
      end =1;
      offset = xoff;
     }
    }
    else
     {
      y=0;
     }
    xoff++;
    if (xoff==512) end=1;
  }
  adr+=512;
 }
 if (found==1)
 {
  adr-=512;            /* Korrektur */
  length_file=0;
  if(offset<22)
  {
   read_single_block(adr+(unsigned long int)offset-22,0);
   offset=22;  
  } 
  pot=1;
  for (j=14; j<23;j++)
  {
  
   length_file=length_file+((data[offset-j]-0x30)*pot);
   pot*=10;
  }
  
  return (adr+(unsigned long int)offset);
  
 }
 else
 {
  return (0);

 }
}
 
 unsigned long int seek_pat(void)         /* sucht nach Pattern */
{
 unsigned long int adr,pot;
 unsigned char y,end,da,b,found,len;
 unsigned int xoff,j,offset;
 unsigned int sa_rate;

 adr=0;
 offset=0;
 found =0;
 while ((adr<memcap[0])&(found==0)&(USR0_RDRF == 0))
 {
  if( read_single_block(adr,0)&0xFF00)
  {
   //print ("Kartenlesefehler");
   return;
  }
  y=0;
  xoff=0;
  end=0;
  while (end!=1)
  {
    da=data[xoff];
    if (da==input[y])
    {
     y++;
     if (input[y]==0)
     {
      found=1;
      end =1;
      offset = xoff;
     }
    }
    else
     {
      y=0;
     }
    xoff++;
    if (xoff==512) end=1;
  }
  adr+=512;
 }
 if (found==1)
 {
  adr-=512;            /* Korrektur */
  length_file=0;
  
  len=0;
  while(input[len]!=0) len++;

  return (adr+(unsigned long int)offset-len+1);
  
 }
 else
 {
  return (0);

 }

 
}
